import { ISDL, IGQLType } from 'prisma-datamodel';
import { INormalizer } from './normalizer';
/**
 * We remove the relation name of type pairs which have exactly a single relation between them.
 * Except the relation name is explicitely declared in the base model. Then, we keep it.
 */
export declare class RemoveRelationName implements INormalizer {
    protected baseModel: ISDL | null;
    constructor(baseModel: ISDL | null);
    normalizeType(type: IGQLType, ref: IGQLType | undefined): void;
    normalize(model: ISDL): void;
}
